/* GPGPU computation of jacobi algorithm with SINGLE PRECISION!
* 
******************************************************************
* Subroutine Jacobi
* Solves poisson equation on rectangular grid assuming : 
* (1) Uniform discretization in each direction, and 
* (2) Dirichlect boundary conditions 
* 
* Jacobi method is used in this routine 
*
* Input : n,m   Number of grid points in the X/Y directions 
*         dx,dy Grid spacing in the X/Y directions 
*         alpha Helmholtz eqn. coefficient 
*         omega Relaxation factor 
*         f(n,m) Right hand side function 
*         u(n,m) Dependent variable/Solution
*         tolerance Tolerance for iterative solver 
*         maxit  Maximum number of iterations 
*
* Output : u(n,m) - Solution 
*****************************************************************
*/

#define U(j,i) u[(j) * cols + (i)]
#define F(j,i) f[(j) * cols + (i)]
#define UOLD(j,i) uold[(j) * cols + (i)]


/* Performs a single Jacobi iteration on the GPU
* --------------------------------------------------------
* Outer loop has to be distributed among the threads
* Inner loop shall be executed sequentially by each thread
*/

// TODO: Define this method as GPU kernel
// TODO: Add the type qualifiers to the variables
// Note that kernels cannot return a value
float oneJacobiIteration(float* u, float* uold, float* f, int rows, int cols, float ax, float ay, float b, float fRelax, float* residuals) { 

	// TODO: Compute the global index within the arrays (with respect to block and thread ids)
	int idx = 

	// TODO: initialize interim array of residuals
	// check that you do not access memory that has not been allocated
	float residual = 0.0f;

	// TODO: Express the outer loop by starting the kernel with 
	// a corrsponding number of threads

	// TODO: Verify that it is not operated on the boundary elements (and save the residuals)
	for (int j = 1; j <= cols -1, j++) {
		for (int i = 1; i <= cols - 2; i++)
		{
			float fLRes = ( ax * (UOLD(j, i-1) + UOLD(j, i+1))
			+ ay * (UOLD(j-1, i) + UOLD(j+1, i))
			+  b * UOLD(j, i) - F(j, i)) / b;
			U(j,i) = UOLD(j,i) - fRelax * fLRes;
			residual += fLRes * fLRes;
		}
	}
	return residual;
}
