#!/usr/bin/env zsh

### Job name
#BSUB -J CudaJacobi

### File / path where STDOUT & STDERR will be written
### %J is the job id
#BSUB -o cudaJacobi.o%J

### Request GPU Queue (daytime)
#BSUB -a gpu

### Request the time you need for execution in minutes
### Format [hour:]minute
#BSUB -W 15

### Request vitual memory (in MB)
#BSUB -M 512

### Specify your mail address
#BSUB -u <e-mail address>

### Send a mail when job is done
#BSUB -N

module switch intel pgi/12.1
cd $HOME/<path>/F-cuda-jacobi/level01
make release
make run
