module VariableDef
    implicit none

    TYPE JacobiData
        integer :: iRows
        integer :: iCols
        integer :: iIterMax
        real :: fAlpha
        real :: fRelax
        real :: fTolerance
    
!        /* calculated dx & dy */
        real :: fDx
        real :: fDy

!       /* pointers to the allocated memory */
        real, allocatable :: afU(:,:)
        real, allocatable :: afF(:,:)
    
!       /* start and end timestamps */
        double precision :: fTimeStart
        double precision :: fTimeStop

!       /* calculated residual (output jacobi) */
        real :: fResidual

!       /* effective interation count (output jacobi) */
        integer :: iIterCount

!       /* calculated error (output error_check) */
        real :: fError
    
   END TYPE JacobiData

end module VariableDef
